// Optimized Fragment Shader
varying vec4 lmtexcoord;
varying vec4 color;
varying vec3 normalMat;
flat varying vec4 labvalue;
flat varying float emissive;

#if defined ENTITY

/* DRAWBUFFERS:0253*/
#else
/* DRAWBUFFERS:02*/

#endif
void main()
{
    vec4 albedo = texture(texture, lmtexcoord.xy, 0);
    albedo.rgb = toLinear(albedo.rgb * color.rgb);

    vec2 lightmap = lmtexcoord.zw;

    #ifdef NAMETAG_FIX
    if (entityId == 1500)
    {
    //    normal = viewToWorld(vec3(0, 0, 1));

        albedo.rgb *= 2.0;
        if (lmtexcoord.r > 0.0 && lmtexcoord.r < 0.02 && lmtexcoord.g > 0.0351 && lmtexcoord.g < 0.0666)
        {

            albedo.a = 0.0;
        }
        if (lmtexcoord.r > 0.49 && lmtexcoord.r < 0.51 && lmtexcoord.g > 0.49 && lmtexcoord.g < 0.51)
        {
            albedo.a = 0.0;
        }
    }
    #endif

    vec2 materials1 = vec2(color.a, labvalue.z);

    lightmap.x = lightmap.x + emissive;
    // albedo.rgb += emissive * 8.0 * albedo.rgb * albedo.rgb;

    gl_FragData[0] = albedo; // Albedo

    // Pack normals, clamped lightmap, and materials into the second render target.
    gl_FragData[1].rgba = vec4(encodeNormal(normalMat),
                               encodeVec2(clamp(lightmap, 0.0, 1.0)),
                               encodeVec2(materials1));
#ifdef ENTITY
    gl_FragData[2].g = 1;     // Materials indicator
    gl_FragData[3] = vec4(0); // Clear remaining target if needed
#endif
}
